/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		Li-Iondrp[dԊ֐
 *
 *		Li-Ion[d@ɉ[dԊ֐ƒg֐܂݂܂B
 *
 * \par pLq:
 *		AVRxxx: ATmega32U4łUSBoR ݓdr[d\n
 *
 * \par 
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http	://www.atmel.com \n
 *		xEҰ				: avr@atmel.com
 *
 * $Name$
 * $Revision:$
 * $RCSfile$
 * $URL:$
 * $Date:$\n
 ******************************************************************************/

#include "config.h"
#include "enums.h"
#include "structs.h"

#include "battery.h"
#include "charge.h"
#include "chargefunc.h"
#include "main.h"
#include "menu.h"
#include "LIIONspecs.h"

#ifdef __GNUC__
  #include "lib_mcu/pwm/pwm.h"
  #include "lib_mcu/timer/time.h"
#elif __ICCAVR__
  #include "PWM.h"
  #include "time.h"
#else
  #error Current COMPILER not supported
#endif

#ifndef LIION
  #error LIION not defined in main.h!
#endif // LIION

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief [d
 *
 * ̊֐͊eiKɕꂽg̏[d@܂݂܂B\n
 * eiKɑ΂PWMJn/~AvA~A[dҰݒ肳꓾
 * B\n
 * [d֐͕K̏ԂԂAُ킪NȂ肱͎̏[dԂłB
 *
 * \note ƒiKKvƂȂAPmenu.hɂƏԂ`Amenu.c
 *  \ref menu_state[] ł܂߁AĂ̊֐caseǉĂB
 *
 * \note ̕@Li-IondrpłB
 */
unsigned char Charge (unsigned char inp)
{
	unsigned char NextState;

	switch (CurrentState) {
		case ST_PREQUAL:		/* \[d */
		// `ꂽ\[ddŏ[dAُ킪NȂΎ̏ԂƂST_CCURRENTԂ܂B
			ChargeParameters.Current = BAT_CURRENT_PREQUAL;	// [ddw
			ChargeParameters.NextState = ST_CCURRENT;		// d[dԎw
			HaltParameters.HaltFlags = (HALT_VOLTAGE_MAX | HALT_TIME |	// ~׸ގw(dBƎԒ)
										HALT_FLAG_EXHAUSTION);			// (Ԓ߂͏ՓdrӖ܂B)
			HaltParameters.TemperatureMax = BAT_TEMPERATURE_MAX;		// xw
			HaltParameters.TemperatureMin = BAT_TEMPERATURE_MIN;		// xw
			HaltParameters.VoltageMax = BAT_VOLTAGE_PREQUAL;			// dw
			PWM_Start();												// PWMJn
			Time_Set(TIMER_CHG, BAT_TIME_PREQUAL, 0, 0);				// \[dvn
			NextState = ST_PREQUAL_CTRL;								// ̏Ԃ\[dɎw
			break;

		case ST_PREQUAL_CTRL:		/* \[d */
			ChargeParameters.NextState = ST_CCURRENT;					// ̏Ԃd[dɎw
			NextState = ST_CCURRENT;									// ̏Ԃd[dɎw
			if ((HaltNow()!=TRUE)&&(ConstantCurrent() != ST_ERROR))		// ُȂŁA
			{
				ChargeParameters.NextState = ST_PREQUAL_CTRL;			// ̏Ԃ\[dɎw
				NextState = ST_PREQUAL_CTRL;							// ̏Ԃ\[dɎw
			}
			break;

		case ST_CCURRENT:			/* d[d */
			Time_Set(TIMER_CHG,BattData.MaxTime,0,0);					// [dԌvn
			ChargeParameters.Current = BattData.MaxCurrent;				// Ήő[ddw
			ChargeParameters.NextState = ST_CVOLTAGE;					// ̏Ԃd[dɎw
			HaltParameters.VoltageMax = BAT_VOLTAGE_MAX;				// dw
			NextState = ST_CCURRENT_CTRL;								// ̏Ԃd[dɎw
			break;

		case ST_CCURRENT_CTRL:		/* d[d */
			ChargeParameters.NextState = ST_CVOLTAGE;					// ̏Ԃ[dIɎw
			NextState = ST_CVOLTAGE;									// ̏Ԃ[dIɎw
			if ((HaltNow()!=TRUE)&&(ConstantCurrent() != ST_ERROR))	// ُȂŁA
			{
				ChargeParameters.NextState = ST_CCURRENT_CTRL;			// ̏Ԃd[dɎw
				NextState = ST_CCURRENT_CTRL;							// ̏Ԃd[dɎw
			}
			break;

		case ST_CVOLTAGE:			/* d[d */
			ChargeParameters.Voltage = BAT_VOLTAGE_MAX;					// Ήő[ddw
			ChargeParameters.NextState = ST_ENDCHARGE;					// ̏Ԃ[dIɎw
			HaltParameters.HaltFlags = (HALT_CURRENT_MIN | HALT_TIME);	// ~׸ގw(dBƎԒ)
			HaltParameters.CurrentMin = BattData.MinCurrent;			// dw
			NextState = ST_CVOLTAGE_CTRL;								// ̏Ԃd[dɎw
			break;

		case ST_CVOLTAGE_CTRL:		/* d[d */
			ChargeParameters.NextState = ST_ENDCHARGE;					// ̏Ԃ[dIɎw
			NextState = ST_ENDCHARGE;									// ̏Ԃ[dIɎw
			if ((HaltNow()!=TRUE)&&(ConstantVoltage() != ST_ERROR))		// ُȂŁA
			{
				ChargeParameters.NextState = ST_CVOLTAGE_CTRL;			// ̏Ԃd[dɎw
				NextState = ST_CVOLTAGE_CTRL;							// ̏Ԃd[dɎw
			}
			break;

		case ST_ENDCHARGE:			/* [dI */

			PWM_Stop();													// PWM~
			BattData.Charged = TRUE;									// [dς׸ސݒ
			NextState = ST_SLEEP;										// ̏Ԃx~(ذ)Ɏw
			break;

		default:	// ŏI点Ă͂܂BŜ߂ɍď܂B
			NextState = ST_INIT;
			break;
	}
	return(NextState);		// ̏ԕƋɕA
}
